/*
 * @(#)mattrace - matrix operate function 1.02 (Shinichi Asakawa) 21-07-1990
 */
#include <stdlib.h>
#include "matrix_util.h"
#include "fileio_util.h"

int mattrace (matrix A, int n, double *trace)
{
    int i;

    if (A==NULL) {
	fprintf(stderr, "Invalid matrix in mattrace()\n");
	exit (EXIT_FAILURE);
    }
    *trace = 0.0;
    for (i=1; i<=n; i++)
	*trace += *(A+offs(n,n,i,i));
    return OK;
}

scalar matTrace (matrix A, int n)
{
    int i;
    scalar ret=0.0;

    if (A==NULL) {
	fprintf(stderr, "Invalid matrix in mattrace()\n");
	exit (EXIT_FAILURE);
    }

    for (i=1; i<=n; i++)
	ret += *(A+offs(n,n,i,i));
    return ret;
}

