#!/bin/sh

tmpfile=gpt$$

if [ -f $tmpfile ]; then
	rm -f $tmpfile
fi

./$1 2>&1 |egrep 'total_error|SEED' |sed -e 's/total_error= //g' -e 's/^SEED/#SEED/g' >$tmpfile
cat <<EOF>${tmpfile}.gpt
set yrange[0.2:2.2]
set xrange[0:1000]
set terminal gif large size 600,400
set output "${tmpfile}.gif"
plot "$tmpfile"
#pause -1  "Hit return to continue"
EOF
gnuplot ${tmpfile}.gpt
netscape -remote "openURL(file:`pwd`/${tmpfile}.gif)"
rm -rf ${tmpfile} ${tmpfile}.gpt ${tmpfile}.gif
