/* General purpose of my programming

   Copyright (c) 1995, 1996, 1997, 1999 Shinichi ASAKAWA <asakawa@twcu.ac.jp>
 
   Disclaimer:  No guarantees of performance accompany this software,
   nor is any responsibility assumed on the author.  */
#ifndef _GENERAL_H_
#define _GENERAL_H_

#define TRUE    (1 == 1)
#define True    TRUE
#define FALSE   (!TRUE)
#define False   FALSE
#define ERR     (FALSE)
#define YES     (TRUE)
#define NO      (!TRUE)
#define Yes     (TRUE)
#define No      (!TRUE)
#define OK      (TRUE)
#define NG      (!TRUE)
#define FLAG    char
#define bool    char
#define boolean char
#define Boolean char

#if SystemV||SystemV4||defined(SYSV)||defined(SYSV_STRINGS)||defined(__sysv__)
  #define bzero(b,l)      memset((char*)(b),(int)0,(l))
  #define bcmp(b1,b2,l)   memcmp((char*)(b1),(char*)(b2),(l))
  #define bcopy(b1,b2,l)  memmove((char*)(b2),(char*)(b1),(l))
  #define index(s,c)      strchr((s),(c))
#endif 

#include <float.h>
#ifdef eps
#undef eps
#endif
/*
#define    eps     1.192092896E-07
*/
#define eps DBL_EPSILON

#define	Pi	(16.0 * atan(1.0 / 5.0) - 4.0 * atan(1.0 / 239.0))

#ifdef PI
   #undef PI
#endif
#define PI       (Pi)
/* #define	Pi      3.141592653589793238 */

#define E       (2.718281828459045235)
#define LOG_PI  (1.14472988584940017)
#define LOG_2PI (1.83787706640934548)

#define max(a,b)  ((a) > (b) ? (a) : (b))
#define min(a,b)  ((a) < (b) ? (a) : (b))

#define deg2rad(x)	((x) / 180.0 * PI)
#define rad2deg(x)	((x) / PI * 180.0)

#endif _GENERAL_H_
