/*	Calculate the probability according with binomial distribution.
 *	usage: p_bin n k p
 *
 *	compile: tcc -mt -DTEST p_bin.cpp
 *
 *		Written by S.Asakawa 1993/05/04
 */
#include <math.h>
#include "general.h"

double p_bin(int n, int k, double p)
/* ʬۣ¡ʣˤ˽ΨѿϰϤȤΨ */
/* ʤΨݤΩˣԤʤäƣ */
/* Ψ */
{
	register int i;
	double q, ret, temp;

	ret = temp = exp( (double)n * log( q = 1.0 - p));
	for(i=1;i<=k;i++){
		temp *= ((double)(n - i + 1)) * p / ((double)i * q);
		ret += temp;
	}
	return ret;
}

#ifdef TEST
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void usage(void)
{
	fprintf(stderr,"p_bin: Calculate the probability according with binomial distribution\n");
	fprintf(stderr,"usage:p_bin n k p\n");
	exit(FALSE);
}

int main( int argc, char **argv )
{
	int n, k;
	double p;

	if( argc != 4 )	usage();
	n = atoi(argv[1]);
	k = atoi(argv[2]);
	p = atof(argv[3]);

	fprintf(stdout,"%4.5f ", p_bin(n,k,p));
	return TRUE;
}
#endif
